rollup-plugin-es-module-interop
change the rollup commonjs output for external imports to check `module.__esModule`
Last updated 8 months ago by homburg .
Apache-2.0 · Repository · Bugs · Original npm · Tarball · package.json
$ cnpm install rollup-plugin-es-module-interop 
SYNC missed versions from official npm registry.

rollup-plugin-es-module-interop

change the rollup commonjs output for external imports to check module.__esModule

What?

By default, when rollup is configured to output format: 'cjs' code, its require calls look like this:

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var external = _interopDefault(require('external'));

That is, if the imported CommonJS module has a .default property, external will be equal to require('external').default. Else, it will be equal to require('external').

This makes ES modules that were compiled to CommonJS and then published to npm work transparently, because they put their default exports on a .default property. But some CommonJS modules also use the .default property as an actual exported value, and not as a "default export". joi is one example.

Babel uses a different check than Rollup does; it checks for the __esModule property, and if it exists, uses require('external').default. Else, it will use require('external'). The __esModule property is added by every compiler that I know of, and CommonJS modules that have a .default property will not be falsely detected as compiled ES modules.

This plugin swaps the Rollup version of _interopDefault for Babel's version. So, with this plugin you can import joi from 'joi' and it'll work!

npm travis standard

Install

npm install rollup-plugin-es-module-interop

Usage

// rollup.config.js
import esModuleInterop from 'rollup-plugin-es-module-interop'

export default {
  plugins: [
    esModuleInterop()
  ]
}

There are no options. rollup-plugin-es-module-interop will replace the _interopDefault implementation in all format: 'cjs' outputs.

License

Apache-2.0

Current Tags

  • 2.1.0                                ...           latest (8 months ago)

3 Versions

  • 2.1.0                                ...           8 months ago
  • 2.0.0                                ...           2 years ago
  • 1.0.0                                ...           3 years ago
Maintainers (1)
Downloads
Today 0
This Week 0
This Month 1
Last Day 0
Last Week 0
Last Month 5
Dependencies (1)
Dev Dependencies (5)

Copyright 2014 - 2017 © taobao.org |